--------------------------------------------------------------------------------
-- Dropdownmenu                                                               --
--------------------------------------------------------------------------------
local _, ADDON = ...                                 --Includes all functions and variables
local my = UnitName("player")--player name

function ADDON.dropdown:ShowMenu(level, value, owner)
	local info = {}
	if not level then return end
	--<<LEVEL 1>>--
	if level == 1 then
		if ADDON:tcount(ADDON:GetProfs(true))>0 then
			for name,v in ADDON:pairsByKeys(ADDON:GetProfs(true)) do
				local title=true
				for subname,icon in pairs(v) do
					if title then
						local id = ADDON:GetSpellID(name)
						local _icon = nil
						if (id) then _icon=select(3,GetSpellInfo(id)) end
						ADDON.dropdown:AddSpell("|cffffd100"..name.."|r", name, _icon, true)
						title=nil
					end
					if (name~=subname) then ADDON.dropdown:AddSpell("  |T"..icon..":16:16:0:0|t "..subname, subname, nil, true) end
					-- Quicktradeskills
					if (ADDON:scanBagForQuickTradeSkillItems(subname, true)) then ADDON.dropdown:AddArrow("  |T"..icon..":16:16:0:0|t |cffff0000"..subname.."|r",subname) end
				end
			end
		end
		ADDON.dropdown:AddLine()                           --list other chars
		info.func = function() ADDON.dropdown:Open(owner, 'children', function() ADDON.dropdown:ShowFavorites(owner) end) end
		ADDON.dropdown:AddFunc("|cffffd100"..ADDON.L["favorites"].."|r",info.func,"Interface\\AddOns\\Broker_ProfessionsMenu\\icons\\fav.tga")
		ADDON.dropdown:AddArrow("|cff00ff00"..ADDON.L["otherchar"].."|r","tradelinks")  -- not supported anymore by patch 5.4
		
		-- ADDON.dropdown:AddFunc("Test",function() ADDON:OpenAltProfFrame("Sanori", 2259) end)
		
		ADDON.dropdown:AddLine()
		ADDON.dropdown:AddArrow(ADDON.L["settings"],"config")
	--<<LEVEL 2>>--
	elseif level == 2 then
		--Settingsmenu
		if value == "config" then
			ADDON.dropdown:AddTitle("Broker_ProfessionsMenu")
			ADDON.dropdown:AddTitle("|cff707070"..ADDON.version.."|r")
			ADDON.dropdown:AddLine()
			ADDON.dropdown:AddArrow(ADDON.L["quicklaunch"],"quicklaunch")
			ADDON.dropdown:AddArrow(ADDON.L["quicklauncher"],"quicklauncher")
			ADDON.dropdown:AddArrow(ADDON.L["tooltips"],"tooltip")
			--Disable trainer frame
			-- info.func = function(var)
			-- 	ADDON.save[my].config.trainerdisabled = var
			-- 	print("|cffffd100Broker_ProfessionsMenu:|r","|cffff0000"..ADDON.L["relog"].."|r")
			-- end
			-- ADDON.dropdown:AddToggle(ADDON.L["trainerdisabled"], ADDON.save[my].config.trainerdisabled, info.func)
			ADDON.dropdown:AddToggle(ADDON.L["bothfactions"], ADDON.save[my].config.bothfactions, function(var) ADDON.save[my].config.bothfactions=var end)
			ADDON.dropdown:AddLine()
			--Reset CDs
			info.func = function()
				ADDON.save[my].cds={}
				for k,v in pairs(ADDON.save) do
					if v.faction==UnitFactionGroup("player") then
						ADDON.save[k].cds={}
					end
 				end 
				ADDON.secureframe:Hide()
				GameTooltip:Hide()
				ADDON.dropdown:Close(1)
			end
			ADDON.dropdown:AddFunc(ADDON.L["resetcds"], info.func, "Interface\\Icons\\Ability_Rogue_FeignDeath", true)
		--list other chars -- not supported anymore by patch 5.4
		--[[elseif value == "tradelinks" then
			local first=true
			for k,v in ADDON:pairsByKeys(ADDON.save) do
				if (k and k~=UnitName("player") and v.tradelinks and ADDON:tcount(v.tradelinks)>0 and (ADDON.save[my].config.bothfactions or UnitFactionGroup("player")==v.faction)) then
					if (v.class) then
					 	local coords = CLASS_ICON_TCOORDS[v.class]
					 	ADDON.dropdown:AddArrow(k,k,"Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes",nil,nil,
							'iconCoordLeft', coords[1],
							'iconCoordRight', coords[2],
							'iconCoordTop', coords[3],
							'iconCoordBottom', coords[4])
					else
						ADDON.dropdown:AddArrow(k,k)
					end
				end
			end]]
		elseif value == "tradelinks" then
			local first=true
			for k,v in ADDON:pairsByKeys(ADDON.save) do
				if (k and k~=UnitName("player") and v.craftableitems and ADDON:tcount(v.craftableitems)>0 and (ADDON.save[my].config.bothfactions or UnitFactionGroup("player")==v.faction)) then
					if (v.class) then
					 	local coords = CLASS_ICON_TCOORDS[v.class]
					 	ADDON.dropdown:AddArrow(k,k,"Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes",nil,nil,
							'iconCoordLeft', coords[1],
							'iconCoordRight', coords[2],
							'iconCoordTop', coords[3],
							'iconCoordBottom', coords[4])
					else
						ADDON.dropdown:AddArrow(k,k)
					end
				end
			end
		-- Quicktradeskills
		else
			local quick = ADDON:scanBagForQuickTradeSkillItems(value)
			if (quick) then
				local nomats=true
				for _,v in ADDON:pairsByKeys(quick) do
					nomats=nil
					ADDON.dropdown:AddLine('text',v.name,'icon',v.icon,'func',v.func,'secure',v.action,'tooltipFunc',function(self) v.tooltip(self) end)
				end
				if nomats then ADDON.dropdown:AddTitle(ADDON.L.nomats) end
			end
		end
	--<<LEVEL 3>>--
	elseif level == 3 then
		--default professions
		if value == "quicklaunch" then
			ADDON.dropdown:AddArrow("|cffffd100"..ADDON.L["leftclick"].."|r","left")
			ADDON.dropdown:AddArrow("  + "..ADDON.L["shift"],"shiftleft")
			ADDON.dropdown:AddArrow("  + "..ADDON.L["alt"],"altleft")
			ADDON.dropdown:AddArrow("  + "..ADDON.L["ctrl"],"ctrlleft")
			ADDON.dropdown:AddArrow("|cffffd100"..ADDON.L["rightclick"].."|r","right")
			ADDON.dropdown:AddArrow("  + "..ADDON.L["shift"],"shiftright")
			ADDON.dropdown:AddArrow("  + "..ADDON.L["alt"],"altright")
			ADDON.dropdown:AddArrow("  + "..ADDON.L["ctrl"],"ctrlright")
		--quicklauncher
		elseif value == "quicklauncher" then
			for name,icon in ADDON:pairsByKeys(ADDON:GetProfs()) do
				local id = ADDON:GetSpellID(name)
				if (id) then
					local func = function(checked)
						if (checked) then
							ADDON.save[my].quicklauncher[id] = true
							if (not ADDON.quicklauncher[id]) then ADDON.quicklauncher[id]=ADDON:newlauncher(name,icon) end
						else
							ADDON.save[my].quicklauncher[id]=nil
							print("|cffffd100Broker_ProfessionsMenu:|r","|cffff0000"..ADDON.L["relog"].."|r")
						end
					end
					ADDON.dropdown:AddToggle("|T"..icon..":16:16:0:0|t "..name, ADDON.save[my].quicklauncher[id], func)
				end
			end
		--Tooltips
		elseif value == "tooltip" then
			--Craftable By in item tooltips
			ADDON.dropdown:AddToggle(ADDON.L["ShowIfYouCanCraftThisInItemTooltips"],ADDON.save[my].config.tooltip.ShowIfYouCanCraftThisInItemTooltips,function(var) ADDON.save[my].config.tooltip.ShowIfYouCanCraftThisInItemTooltips=var end)
			--ShowAllTooltips
			ADDON.dropdown:AddToggle(ADDON.L["ShowAllTooltips"],ADDON.save[my].config.tooltip.ShowAllTooltips,function(var) ADDON.save[my].config.tooltip.ShowAllTooltips=var end)
			ADDON.dropdown:AddLine()
			--showskills
			ADDON.dropdown:AddToggle(ADDON.L["professions"],ADDON.save[my].config.tooltip.showskills,function(var) ADDON.save[my].config.tooltip.showskills=var end)
			--showcds
			ADDON.dropdown:AddToggle(ADDON.L["showcds"],ADDON.save[my].config.tooltip.showcds,function(var) ADDON.save[my].config.tooltip.showcds=var end)
			--showbuttons
			ADDON.dropdown:AddToggle(ADDON.L["showbuttons"],ADDON.save[my].config.tooltip.showbuttons,function(var) ADDON.save[my].config.tooltip.showbuttons=var end)
			--hide professions
		--list trades from an other char  -- not supported anymore by patch 5.4!
		--[[else
			for k,v in ADDON:pairsByKeys(ADDON.save[value].tradelinks) do
				local name, _, icon = GetSpellInfo(k)
				info.func = function()
					if IsShiftKeyDown() then
						if (not ChatEdit_InsertLink(v) ) then
							ChatFrame1EditBox:Show();
							ChatEdit_InsertLink(v);
						end
					else
						print("|cff00ff00Broker ProfessionsMenu: "..value..": |r"..v)
					end
				end
				info.tooltipFunc = function()
					local skill,maxskill = strmatch(v,"|Htrade:%x+:%d+:(%d+):(%d+):")
					if (skill == nil) then skill = "?" end
					if (maxskill == nil) then maxskill = "?" end
					local frame = GameTooltip:GetOwner()
					GameTooltip:SetOwner(frame, "ANCHOR_NONE")
					GameTooltip:ClearAllPoints()
					GameTooltip:SetPoint(ADDON:GetTipAnchor2(frame))
					GameTooltip:ClearLines()
					GameTooltip:AddLine(value,0,1,0)
					GameTooltip:AddDoubleLine(name,skill.."/"..maxskill,1,1,0,0,1,0)
					GameTooltip:AddTexture(icon)
					GameTooltip:AddLine(" ")
					GameTooltip:AddLine(ADDON.L["leftclick"]..": |cffffffff"..ADDON.L["linktome"].."|r")
					GameTooltip:AddLine(ADDON.L["shift"].." + "..ADDON.L["leftclick"]..": |cffffffff"..ADDON.L["linktoother"].."|r")
				end
				ADDON.dropdown:AddFunc(name,info.func,icon,nil,info.tooltipFunc)
			end
			ADDON.dropdown:AddLine()
			info.tooltipFunc = function()
				local frame = GameTooltip:GetOwner()
				GameTooltip:SetOwner(frame, "ANCHOR_NONE")
				GameTooltip:ClearAllPoints()
				GameTooltip:SetPoint(ADDON:GetTipAnchor2(frame))
				GameTooltip:ClearLines()
				GameTooltip:AddLine(ADDON.L["deletechartooltip"])
			end
			ADDON.dropdown:AddFunc(DELETE,function() ADDON.save[value]=nil end,nil,true,info.tooltipFunc)]]
		else
			for k,_ in ADDON:pairsByKeys(ADDON.save[value].craftableitems) do
				local name, _, icon = GetSpellInfo(k)
				ADDON.dropdown:AddFunc(name,function() ADDON:OpenAltProfFrame(value, k) end,icon)
			end
			ADDON.dropdown:AddLine()
			info.tooltipFunc = function()
				local frame = GameTooltip:GetOwner()
				GameTooltip:SetOwner(frame, "ANCHOR_NONE")
				GameTooltip:ClearAllPoints()
				GameTooltip:SetPoint(ADDON:GetTipAnchor2(frame))
				GameTooltip:ClearLines()
				GameTooltip:AddLine(ADDON.L["deletechartooltip"])
			end
			ADDON.dropdown:AddFunc(DELETE,function() ADDON.save[value]=nil end,nil,true,info.tooltipFunc)
		end
	--<<LEVEL 4>>--
	elseif level == 4 then
		-- Check, if Menu is min. one time selected
		local disabled = true;
		for k,v in pairs(ADDON.save[my].quicklaunch) do	-- Menu must be asigned min. one times
			if (v=="menu" and k~=value) then
				disabled=false
				break
			end
		end
		-- No Profession
		if (ADDON.save[my].quicklaunch[value] == 0) then info.checked = true else info.checked = nil end
		info.func = function(var) ADDON.save[my].quicklaunch[value] = 0 end
		ADDON.dropdown:AddToggle("---", info.checked, info.func, nil, "disabled", disabled)
		ADDON.dropdown:AddLine()
		-- Open Last Profession Window
		if (ADDON.save[my].quicklaunch[value] == -1) then info.checked = true else info.checked = nil end
		info.func = function(var) ADDON.save[my].quicklaunch[value] = -1 end
		ADDON.dropdown:AddToggle(ADDON.L['openLastProfessionWindow'], info.checked, info.func, nil, "disabled", disabled)
		-- Menu
		if (ADDON.save[my].quicklaunch[value] == "menu") then info.checked = true else info.checked = nil end
		info.func = function(var) ADDON.save[my].quicklaunch[value] = "menu" end
		ADDON.dropdown:AddToggle(ADDON.L["openmenu"], info.checked, info.func, nil, "disabled", disabled)
		-- Favorites
		if (ADDON.save[my].quicklaunch[value] == "fav") then info.checked = true else info.checked = nil end
		info.func = function(var) ADDON.save[my].quicklaunch[value] = "fav" end
		ADDON.dropdown:AddToggle(ADDON.L["showfavorites"], info.checked, info.func, nil, "disabled", disabled)
		-- Select Profession
		ADDON.dropdown:AddLine()
		for k,icon in ADDON:pairsByKeys(ADDON:GetProfs()) do
			info.func = function() ADDON.save[my].quicklaunch[value] = ADDON:GetSpellID(k) end
			local spell = GetSpellInfo(ADDON.save[my].quicklaunch[value])
			if spell == GetSpellInfo(k) then info.checked = true else info.checked = nil end
			ADDON.dropdown:AddToggle("|T"..icon..":18:18:0:0|t "..k, info.checked, info.func, nil, "disabled", disabled)
		end
	end
--<<END LEVEL>>--
end --function()



function ADDON.dropdown:ShowFavorites(owner)
	local first=true
	for profid,v in pairs(ADDON.save[my].favorites) do
		local prof,_ = GetSpellInfo(profid)
		if not first then ADDON.dropdown:AddLine() end
		first=nil
		ADDON.dropdown:AddTitle(prof)
		local table = {}
		for recipeid,type in pairs(v) do
			local name,_,icon =GetSpellInfo(recipeid)
			table[name] = {
				id = recipeid,
				icon = icon,
				type = type,
				tooltip=function()
					local frame = GameTooltip:GetOwner()
					GameTooltip:SetOwner(frame, "ANCHOR_NONE")
					GameTooltip:ClearAllPoints()
					GameTooltip:SetPoint(ADDON:GetTipAnchor2(frame))
					GameTooltip:ClearLines()
					GameTooltip:SetHyperlink("|cffffffff|Henchant:"..tostring(recipeid).."|h["..name.."]|h|r")
					GameTooltip:AddLine(' ')
					--Cooldowns
					local duration=ADDON.save[my].cds[name]
					if ADDON.P.SharedCDs[recipeid] then
						duration=ADDON.save[my].cds[ADDON.P.SharedCDs[recipeid]]
					end
					if duration then
						duration = difftime(duration,time())
						if duration > 0 then
							GameTooltip:AddDoubleLine(COOLDOWN_REMAINING,SecondsToTime(duration),1,0,0,1,0,0)
							GameTooltip:AddLine(' ')
						end
					end
					if type=="Create" then
						GameTooltip:AddDoubleLine(ADDON.L["leftclick"],"|cffffffff"..CREATE_PROFESSION.."|r")
						GameTooltip:AddDoubleLine(ADDON.L["shift"].." + "..ADDON.L["leftclick"],"|cffffffff"..CREATE_ALL.."|r")
					else
						GameTooltip:AddDoubleLine(ADDON.L["leftclick"],"|cffffffff"..type.."|r")
					end
					GameTooltip:AddDoubleLine(ADDON.L["alt"].." + "..ADDON.L["leftclick"],"|cffffffff"..DELETE.."|r")
				end,
			}
		end
		for kk,vv in ADDON:pairsByKeys(table) do
			local func = function()
				if IsAltKeyDown() then --Delete Favorite
					local data = ADDON.save[my].favorites[profid]
					data[vv.id] = nil
					if ADDON:tcount(data) == 0 then
						data = nil
					end
					ADDON.save[my].favorites[profid] = data
					if TradeSkillFrame:IsVisible() then
						TradeSkillFrame_Update()
					end
				else --Craft Item
					CloseTradeSkill()
					CastSpellByName(prof)
					for i=1, GetNumTradeSkills() do
						local skillname,skilltype,numAvailable,isExpanded,_ = GetTradeSkillInfo(i)
						if skilltype=='header' and not isExpanded then
							ExpandTradeSkillSubClass(i)
						elseif skillname==kk then
							local num = 1
							if IsShiftKeyDown() and vv.type=="Create" then
								num = numAvailable
							end
							TradeSkillFrame_SetSelection(i)
							TradeSkillFrame_Update()
							TradeSkillInputBox:SetNumber(num)
							DoTradeSkill(i, num)
							TradeSkillInputBox:ClearFocus()
							ADDON.dropdown:Open(owner, 'children', function() ADDON.dropdown:ShowFavorites(owner) end)--Reopen Dropdownmenu
							break
						end
					end
				end
			end
			ADDON.dropdown:AddFunc(kk,func,vv.icon,nil,vv.tooltip)
		end
	end
	if first then ADDON.dropdown:AddTitle(ADDON.L.nofavorites) end
end



--dropdown wrapper functions
--create a toggle (use func(var) to save you var)
function ADDON.dropdown:AddToggle(name, var, func, tooltipfunc, ...)
	local lfunc = function()
		var = not var
		if func then func(var) end
	end
	local checked = false
 	if var then checked=true end
 	if not tooltipfunc then tooltipfunc=function() return end end
	ADDON.dropdown:AddLine('text',name,'func',lfunc,'checked',checked,'tooltipFunc',tooltipfunc,...)
end
--create a button
function ADDON.dropdown:AddFunc(name, func, icon, closewhenclicked, tooltipfunc, ...)
	if closewhenclicked==nil then closewhenclicked=false end
	if not tooltipfunc then tooltipfunc=function() return end end
	ADDON.dropdown:AddLine('text',name,'icon',icon,'func',func,'tooltipFunc',tooltipfunc,'closeWhenClicked',closewhenclicked,...)
end
function ADDON.dropdown:AddSpell(name, spell, icon, closewhenclicked, tooltipfunc, ...)
	if closewhenclicked==nil then closewhenclicked=false end
	if not tooltipfunc then tooltipfunc=function() return end end
	ADDON.dropdown:AddLine('text',name,'icon',icon,'secure',{type1='spell',spell=spell},'tooltipFunc',tooltipfunc,'closeWhenClicked',closewhenclicked,...)
end
--create a submenu
function ADDON.dropdown:AddArrow(name, value, icon, tooltipfunc, func, ...)
	if not tooltipfunc then tooltipfunc=function() return end end
	ADDON.dropdown:AddLine('hasArrow',true,'text',name,'icon',icon,'value',value,'tooltipFunc',tooltipfunc,...)
end
--add title line
function ADDON.dropdown:AddTitle(name, icon, ...)
	ADDON.dropdown:AddLine('isTitle',true,'text',name,'icon',icon,...)
end